//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D40493D01C1.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D40493D01C1.cm

//## begin module%3D40493D01C1.cp preserve=no
//## end module%3D40493D01C1.cp

//## Module: SwitchParam%3D40493D01C1; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/SwitchParam.cxx

//## begin module%3D40493D01C1.additionalIncludes preserve=no
//## end module%3D40493D01C1.additionalIncludes

//## begin module%3D40493D01C1.includes preserve=yes
//## end module%3D40493D01C1.includes

// SwitchParam
#include <XSModel/Parameter/SwitchParam.h>
//## begin module%3D40493D01C1.declarations preserve=no
//## end module%3D40493D01C1.declarations

//## begin module%3D40493D01C1.additionalDeclarations preserve=yes
#include <XSUtil/Utils/XSutility.h>
#include <XSModel/Model/Component/ComponentBase.h>
#include <XSModel/Parameter/ParameterLink.h>
#include <XSstreams.h>
#include <sstream>
#include <iomanip>
#include <cmath>

//## end module%3D40493D01C1.additionalDeclarations


// Class SwitchParam 

SwitchParam::SwitchParam(const SwitchParam &right)
  //## begin SwitchParam::SwitchParam%38EB53DB0C78_copy.hasinit preserve=yes
      : Parameter(right),m_state(right.m_state)
  //## end SwitchParam::SwitchParam%38EB53DB0C78_copy.hasinit
  //## begin SwitchParam::SwitchParam%38EB53DB0C78_copy.initialization preserve=yes
  //## end SwitchParam::SwitchParam%38EB53DB0C78_copy.initialization
{
  //## begin SwitchParam::SwitchParam%38EB53DB0C78_copy.body preserve=yes
  //## end SwitchParam::SwitchParam%38EB53DB0C78_copy.body
}

SwitchParam::SwitchParam (const string& initString, ComponentBase* p)
  //## begin SwitchParam::SwitchParam%3A92A25E0229.hasinit preserve=yes
     : Parameter(p),m_state(0)
  //## end SwitchParam::SwitchParam%3A92A25E0229.hasinit
  //## begin SwitchParam::SwitchParam%3A92A25E0229.initialization preserve=yes
  //## end SwitchParam::SwitchParam%3A92A25E0229.initialization
{
  //## begin SwitchParam::SwitchParam%3A92A25E0229.body preserve=yes
  init(initString);  
  //## end SwitchParam::SwitchParam%3A92A25E0229.body
}


SwitchParam::~SwitchParam()
{
  //## begin SwitchParam::~SwitchParam%38EB53DB0C78_dest.body preserve=yes
  //## end SwitchParam::~SwitchParam%38EB53DB0C78_dest.body
}



//## Other Operations (implementation)
SwitchParam* SwitchParam::clone (ComponentBase* p) const
{
  //## begin SwitchParam::clone%38EB56D380B0.body preserve=yes
  SwitchParam* cloned = new SwitchParam(*this);
  cloned->parent(p);
  return cloned;   
  //## end SwitchParam::clone%38EB56D380B0.body
}

std::ostream& SwitchParam::put (std::ostream& s) const
{
  //## begin SwitchParam::put%38EB6698DB80.body preserve=yes
  using namespace std;
  ios_base::fmtflags saveFlags(s.flags());
  const ComponentBase* component = parent();
  s  << setw(4) << index()   
     << setw(5) << component->index() << "   "
     << setw(11) << left << component->name() 
     << setw(11) << left << name()
     << setw(9) << left << " ";
  int setting = static_cast<int>(value()); 
  s << left << setw(13) << setting;
  if (isLinked())
     thisLink()->putLink(s);
  else
     s << "frozen";
  s.flags(saveFlags);
  //## end SwitchParam::put%38EB6698DB80.body

  return s;
}

bool SwitchParam::compare (const Parameter& right) const
{
  //## begin SwitchParam::compare%38EB882D5120.body preserve=yes
  if (!Parameter::compare(right)) return false; 
  const SwitchParam& that = static_cast<const SwitchParam&>(right);
  if ( m_state != that.m_state ) return false;
  return true;  
  //## end SwitchParam::compare%38EB882D5120.body
}

void SwitchParam::init (const string& initString)
{
  //## begin SwitchParam::init%38ECDA0E3B78.body preserve=yes
  std::istringstream s(initString);
  string parname;
  int state = 0;
  s >> parname >> state;
  name(parname.substr(1,parname.length()-1));
  setValue(state);  
  //## end SwitchParam::init%38ECDA0E3B78.body
}

void SwitchParam::changeValue (const string& parString)
{
  //## begin SwitchParam::changeValue%38F642390998.body preserve=yes
  using std::ios_base;
  string::size_type begin = parString.find_first_not_of(" \t");
  if (begin == string::npos)
  {
     return;
  }

  // remove the link if any and reset the parameter to its file values
  // without preserving current setting
  untie(false); 
  
  string processedStr = XSutility::lowerCase(parString.substr(begin));
  // remove trailing blanks
  string::size_type end = processedStr.find_last_not_of(" \t");
  processedStr = processedStr.substr(0, end+1);
  Real inTest=0.0;
  int newState=0;
  
  // For backwards compatibility, check for true/false entry.
  if (processedStr == "true")
  {
     newState = 1;
  }
  else if (processedStr == "false")
  {
     newState = 0;
  }
  else
  {
     std::istringstream s(processedStr);
     string errMsg = "Parameter "+ name() + ":  integer value required ";
     if (!(s >> inTest) || !s.eof())
     {
        throw Parameter::InvalidInput(errMsg);
     }
     newState = static_cast<int>(std::floor(inTest));
     if (inTest != static_cast<Real>(newState))
     {
        tcout << "***Warning: Switch parameter requires an integer."
         << "\n    Floating-point value will be truncated." << std::endl;
     }
  }
  setValue(newState);  
  //## end SwitchParam::changeValue%38F642390998.body
}

void SwitchParam::link (const string& toLink)
{
  //## begin SwitchParam::link%38F642691A98.body preserve=yes
  thisLink(new ParameterLink(toLink,this,true));
  links()->linkList(this,thisLink());
  isLinked(true);  
  //## end SwitchParam::link%38F642691A98.body
}

Real SwitchParam::value () const
{
  //## begin SwitchParam::value%39009207E360.body preserve=yes
        
  if (!isLinked()) return static_cast<Real>(m_state);
  else return thisLink()->linkValue();  
  //## end SwitchParam::value%39009207E360.body
}

void SwitchParam::setValue (int state)
{
  //## begin SwitchParam::setValue%3900945BC410.body preserve=yes
  if (m_state != state)
  {
          m_state = state;
          changed(true);
          setCompute(true);
          setComputeForLinks(true);
  }
  //## end SwitchParam::setValue%3900945BC410.body
}

void SwitchParam::doPreserve ()
{
  //## begin SwitchParam::doPreserve%3C0FD49902E8.body preserve=yes
  if (isLinked())
  {
        int currentValue = static_cast<int>(thisLink()->linkValue());
        links()->unlink(this);
        reset();
        m_state = currentValue;       
  }  
  //## end SwitchParam::doPreserve%3C0FD49902E8.body
}

string SwitchParam::stringVal () const
{
  //## begin SwitchParam::stringVal%3CEC00B501B9.body preserve=yes
  std::ostringstream val;
  val << m_state << " " << name();
  return val.str();
  //## end SwitchParam::stringVal%3CEC00B501B9.body
}

string SwitchParam::parameterSetting () const
{
  //## begin SwitchParam::parameterSetting%3F2E79DB0116.body preserve=yes
    std::ostringstream val;
    if (!isLinked())
    {
       val << std::setw(15) << m_state;
    }
    else
    {
          val << "= " << thisLink()->linkExpression(false);
    }
    return val.str();
  //## end SwitchParam::parameterSetting%3F2E79DB0116.body
}

// Additional Declarations
  //## begin SwitchParam%38EB53DB0C78.declarations preserve=yes
  //## end SwitchParam%38EB53DB0C78.declarations

//## begin module%3D40493D01C1.epilog preserve=yes
//## end module%3D40493D01C1.epilog
